var DataType = {
	NONE: 0,
	LIST: 1,
	SEARCH: 2,
	ITEM: 3
};

//raw api
var movies = [];
function addMovie(obj){
	movies.push(obj);
}
//--

var $$connector = null;

function Connector(readyCallback)
{
	var o = this;
	$$connector = this;
	
	this.displayItemsOnPage = 10;

	this.selectedItem = null;
	
	this.currentPage = 0;
	this.pagesCount = 0;
	this.hasMorePages = false;
	
	this.OnReady = readyCallback;
	this.OnUpdatedContent = null;
	this.OnPlay = null;
	
	this.movies = null;
	this.lastResultType = DataType.NONE;
	this.lastResult = null;
	
	this.UpdateContent = function ()
	{
		if(this.selectedItem === null)
		{
			this.hasMorePages = this.currentPage < this.pagesCount;
			this.lastResult = [];
			for(var i = 0, ii = this.currentPage * this.displayItemsOnPage;
				i < this.displayItemsOnPage && ii < this.movies.length; i++, ii++)
				this.lastResult.push(this.movies[ii]);
			this.lastResultType = DataType.LIST;
		}
		else
		{
			this.lastResult = this.selectedItem;
			this.lastResultType = DataType.ITEM;
		}
		if(this.OnUpdatedContent != null)
			this.OnUpdatedContent(this);
	};
	
	this.Preload = function ()
	{
		var count = 0;
		for(var i = 0; i < this.movies.length; i++)
		{
			(function(){
				var ii = i;
				$.get("http://175h.net/kinopoisk/" + o.movies[i].kinopoisk + ".xml", function(data, textStatus, jqXHR) {
					var rating_kp = $(data).find("kp_rating")[0];
					rating_kp = rating_kp != undefined && rating_kp.textContent != undefined ? parseFloat(rating_kp.textContent) : null;
					var rating_imdb = $(data).find("imdb_rating")[0];
					rating_imdb = rating_imdb != undefined && rating_imdb.textContent != undefined ? parseFloat(rating_imdb.textContent) : null;
					var rating = null;
					if(rating_kp !== null && rating_imdb !== null)
						rating = (rating_kp + rating_imdb) / 2;
					else if(rating_kp !== null)
						rating = rating_kp;
					else if(rating_imdb !== null)
						rating = rating_imdb;
					if(rating !== null)
					{
						o.movies[ii].rating = rating;
						if(rating_kp !== null)
							o.movies[ii].rating_kinopoisk = rating_kp;
						if(rating_imdb !== null)
							o.movies[ii].rating_imdb = rating_imdb;
					}
					if(++count >= o.movies.length)
					{
						for(var i = 0; i < o.movies.length; i++)
						{
							o.movies[i].internalId = i;
							o.movies[i].image_url = "http://175h.net/" + o.movies[i].id + "/p.jpg";
							if(o.movies[i].time)
								o.movies[i].runtime = {
									hours: Math.floor(o.movies[i].time / 60),
									minutes: o.movies[i].time % 60
								};
						}
						o.pagesCount = Math.ceil(o.movies.length / o.displayItemsOnPage);
						o.OnReady();
						o.UpdateContent();
					}
				}, "xml");
			})();
		}
	}
	
	$.get( "http://175h.net/id.js", function(data, textStatus, jqXHR) {
		var items = id;
		id = undefined;
		var counter = items.length;
		for(var i = 0; i < items.length; i++)
		{
			$.get("http://175h.net/" + items[i] + "/a.js", function(data, textStatus, jqXHR) {
				if(movies.length >= items.length)
				{
					o.movies = movies;
					movies = undefined;
					addMovie = undefined;
					o.Preload();
				}
			}, "script");
			//http://175h.net/kinopoisk/762738.xml
		}
	}, "script");
};

Connector.prototype.NextPage = function()
{
	if(!this.hasMorePages || this.selectedItem != null)
		return false;
	this.currentPage++;
	this.UpdateContent();
	return true;
}

Connector.prototype.PrevPage = function()
{
	if(this.currentPage == 0 || this.selectedItem != null)
		return false;
	this.currentPage--;
	this.UpdateContent();
	return true;
}

Connector.prototype.ContentType = function()
{
	return this.lastResultType;
}

Connector.prototype.Content = function()
{
	return this.lastResult;
}

Connector.prototype.Pages = function()
{
	return this.pagesCount;
}

Connector.prototype.Page = function()
{
	return this.currentPage + 1;
}

Connector.prototype.IsNavigating = function()
{
	return false;
}

Connector.prototype.Return = function()
{
	if(this.navigating)
		return;
	if(this.selectedItem != null)
	{
		this.selectedItem = null;
		this.UpdateContent();
		return;
	}
}

Connector.prototype.Select = function(id)
{
	if(this.selectedItem != null)
		return;
	if(this.lastResultType != DataType.LIST && this.lastResultType != DataType.SEARCH)
		return;
	this.selectedItem = this.movies[id];
	this.UpdateContent();
}

Connector.prototype.Play = function(id)
{
	var data = {url: "http://175h.net/" + this.movies[id].id + "/" + this.movies[id].quality + ".mp4"};
	if(this.OnPlay != null)
		this.OnPlay(this, data);
}
