(function () {
  "use strict";


  window.App = {
    currentScene: null,
    scenes: {},
    isShown: true,
	navigatingFrom: -1,
	
    initialize: function () {
		$("#back_button").hide();
		$$legend.keys.tools("");
		var o = this;
		var bg = $('.bg');
		this.waitscreen = true;
		this.$connector = new Connector(function(){o.postInitialize();});
		this.$player = new PlayerControl();
		this.$connector.OnUpdatedContent = function(){o.updateContent();};
		this.$connector.OnPlay = function(c, data){
			o.$player.Play(data.url);
		};
		this.$player.OnPlay = function() {
			bg.hide();
			o.toggleView(false);
		};
		this.$player.OnStop = function() {
			bg.show();
			if(o.isShown)
			{
				$$legend.show();
				$$legend.keys.tools("");
			}
			o.toggleView(true);
			o.updateLegend();
		};
    },
	
	postInitialize: function () {
		this.$wrap = $('.wrap');
		$$legend.show();
		this.setEvents();
		$$nav.on();
    },

    setEvents: function () {
      var self = this,
        $bg = $('.bg');
	  
	  $(".navigation-item").on('click', function( e ) {
		var internalId = parseInt(e.currentTarget.getAttribute('internal_id'));
		self.$connector.Select(internalId);
	  });

      $(document.body).on({
		'nav_key:num': function ( e ) {
			if(!self.isShown || self.$connector.IsNavigating())
				return;
			var type = self.$connector.ContentType();
			if(type != DataType.LIST && type != DataType.SEARCH)
				return;
			var num = parseInt(e.num);
			if(num == NaN)
				return;
			num -= 1;
			if(num < 0)
				num += 10;
			var element = $(".navigation-item")[num];
			if(!$(element).is(":visible"))
				return;
			$$nav.current(element, "page_auto");
			$(element).trigger("click");
        },
		
		'nav_key:return': function ( e ) {
			if(!self.isShown || e.handled)
				return;
			var back_button = $('#back_button');
			if(back_button.is(':visible'))
				back_button.trigger("click");
        },
		
		'nav_key:tools': function ( e ) {
			if(!self.isShown)//show menu
			{
				self.$player.External(true);
				self.toggleView();
				self.updateLegend();
				$$nav.current($("#menu_button_red")[0]);
			}
			else if(self.$player.IsExternal())//hide menu
			{
				self.toggleView();
				self.$player.External(false);
			}
        },
		
		'nav_key:rew': function( e ) {
			if(!self.isShown)
				return;
			if(self.$connector.ContentType() == DataType.ITEM)
				self.scrollUp();
			else
				self.quickPagingPrev();
			return;
		},
		'nav_key:ff': function( e ) {
			if(!self.isShown)
				return;
			if(self.$connector.ContentType() == DataType.ITEM)
				self.scrollDown();
			else
				self.quickPagingNext();
			return;
		},

        // remote events
        'nav_key:exit': function(){
			self.$player.ForceStop();
			SB.exit();
        }
      });
	  $(".navigation-item").on({
			'nav_key:up': _.bind(this.tryPagingPrev, this),
			'nav_key:down': _.bind(this.tryPagingNext, this)
	  });


    },
	
	tryPagingNext: function (e) {
		if(!this.isShown)
			return;
		var ct = this.$connector.ContentType();
		if(this.$connector.IsNavigating() || (ct != DataType.LIST && ct != DataType.SEARCH))
			return;
		var from = e.target.getAttribute("nav_num");
		if(from == null)
			return;
		from = parseInt(from);
		if(from === NaN)
			return;
		if(from <= 4)
			return;
		if(this.$connector.NextPage())
			this.navigatingFrom = from;
	},
	
	tryPagingPrev: function (e) {
		if(!this.isShown)
			return;
		var ct = this.$connector.ContentType();
		if(this.$connector.IsNavigating() || (ct != DataType.LIST && ct != DataType.SEARCH))
			return;
		var from = e.target.getAttribute("nav_num");
		if(from == null)
			return;
		from = parseInt(from);
		if(from === NaN)
			return;
		if(from > 4)
			return;
		if(this.$connector.PrevPage())
			this.navigatingFrom = from;
	},
	
	quickPagingNext: function () {
		var ct = this.$connector.ContentType();
		if(this.$connector.IsNavigating() || (ct != DataType.LIST && ct != DataType.SEARCH))
			return;
		var navFrom = -1;	
		var e = $(".navigation-item.focus");
		if(e.length > 0)
		{
			var from = e[0].getAttribute("nav_num");
			if(from != null)
			{
				from = parseInt(from);
				if(from !== NaN)
					navFrom = from;
			}
		}
		if(this.$connector.NextPage())
			this.navigatingFrom = navFrom;
	},
	
	quickPagingPrev: function () {
		var ct = this.$connector.ContentType();
		if(this.$connector.IsNavigating() || (ct != DataType.LIST && ct != DataType.SEARCH))
			return;
		var navFrom = -1;	
		var e = $(".navigation-item.focus");
		if(e.length > 0)
		{
			var from = e[0].getAttribute("nav_num");
			if(from != null)
			{
				from = parseInt(from);
				if(from !== NaN)
					navFrom = from;
			}
		}
		if(this.$connector.PrevPage())
			this.navigatingFrom = navFrom;
	},
	
	scrollUp: function() {
		var ct = this.$connector.ContentType();
		if(this.$connector.IsNavigating() || ct != DataType.ITEM)
			return;
		var scroller = $(".item-wrapper");
		var limitter = $(".item-limiter");
		if(!scroller.length || !limitter.length)
			return;
		var scrollerHeight = scroller.height();
		var limitterHeight = limitter.height();
		var maxScroll = scrollerHeight - limitterHeight;
		if(maxScroll <= 0)
			return;
		var scrollPosition = scroller[0].getAttribute("scrollPosition");
		if(scrollPosition === null)
		{
			scrollPosition = 0;
			scroller[0].setAttribute("scrollPosition", 0);
		}
		else
			scrollPosition = parseInt(scrollPosition);
		var newScrollPosition = scrollPosition - limitterHeight;
		if(newScrollPosition < 0)
			newScrollPosition = 0;
		if(scrollPosition == newScrollPosition)
			return;
		scroller[0].setAttribute("scrollPosition", newScrollPosition);
		scroller.css("top", (newScrollPosition ? -newScrollPosition : 0) + "px");
	},
	
	scrollDown: function() {
		var ct = this.$connector.ContentType();
		if(this.$connector.IsNavigating() || ct != DataType.ITEM)
			return;
		var scroller = $(".item-wrapper");
		var limitter = $(".item-limiter");
		if(!scroller.length || !limitter.length)
			return;
		var scrollerHeight = scroller.height();
		var limitterHeight = limitter.height();
		var maxScroll = scrollerHeight - limitterHeight;
		if(maxScroll <= 0)
			return;
		var scrollPosition = scroller[0].getAttribute("scrollPosition");
		if(scrollPosition === null)
		{
			scrollPosition = 0;
			scroller[0].setAttribute("scrollPosition", 0);
		}
		else
			scrollPosition = parseInt(scrollPosition);
		var newScrollPosition = scrollPosition + limitterHeight;
		if(newScrollPosition > maxScroll)
			newScrollPosition = maxScroll;
		if(scrollPosition == newScrollPosition)
			return;
		scroller[0].setAttribute("scrollPosition", newScrollPosition);
		scroller.css("top", (newScrollPosition ? -newScrollPosition : 0) + "px");
	},

    toggleView: function (status) {
		if(status !== undefined)
		{
			if(this.isShown ^ status)
				this.toggleView();
			return;
		}
		if (this.isShown) {
			this.$wrap.hide();
			$$legend.keys.tools("Меню");
			$$legend.hide();
		} else {
			this.$wrap.show();
			$$legend.show();
			if(this.$player.IsExternal())
				$$legend.keys.tools("Продолжить просмотр");
			else
				$$legend.keys.tools("");
		}
		this.isShown = !this.isShown;
    },
	
	updateContent: function () {
		if(this.$player.IsExternal())
			this.$player.ForceStop();
		var type = this.$connector.ContentType();
		switch(type)
		{
			case DataType.NONE:
				$(".scenes-wrapper, .scenes-wrapper .scene-list, .scenes-wrapper .scene-item").hide();
				break;
			case DataType.LIST:
				$(".scenes-wrapper, .scenes-wrapper .scene-list").show();
				$(".scenes-wrapper .scene-item").hide();
				var items = this.$connector.Content();
				var blocks = this.renderPage(items, this.$connector.Page(), this.$connector.Pages());
				var select = 0;
				if(items.length > 0)
				{
					if(this.navigatingFrom >= 0)
					{
						select = this.navigatingFrom;
						this.navigatingFrom = -1;
					}
					if(select >= items.length)
						select -= 5;
					if(select < 0 || select >= items.length)
						select = 0;
					$$nav.current(blocks[select], "page_auto");
				}
				break;
			case DataType.ITEM:
				$(".scenes-wrapper, .scenes-wrapper .scene-item").show();
				$(".scenes-wrapper .scene-list").hide();
				var item = this.$connector.Content();
				var focus = this.renderItem(item);
				$$nav.current(focus, "page_auto");
				break;
		}
		this.updateLegend();
		if(this.waitscreen)
		{
			this.waitscreen = false;
			$("body")[0].removeChild($(".waitscreen")[0]);
		}
	},
	
	updateLegend: function () {
		var type = this.$connector.ContentType();
		switch(type)
		{
			case DataType.NONE:
				$$legend.keys.ret("");
				$$legend.keys.rew("");
				$$legend.keys.ff("");
				$$legend.keys.number("");
				break;
			case DataType.SEARCH:
				$$legend.keys.ret("Назад");
			case DataType.LIST:
				if(type == DataType.LIST)
					$$legend.keys.ret("");
				$$legend.keys.rew("Предидущая страница");
				$$legend.keys.ff("Следующая страница");
				$$legend.keys.number("Выбрать");
				break;
			case DataType.ITEM:
				$$legend.keys.ret("Назад");
				$$legend.keys.rew("Прокрутка вверх");
				$$legend.keys.ff("Прокрутка вниз");
				$$legend.keys.number("");
				break;
		}
	},
	
	renderItem: function (item) {
		var o = this;
		var block = $(".scene-item")[0];
		while(block.childNodes.length > 0)
			block.removeChild(block.childNodes[0]);
		if(item == null)
			return this.renderNotFound(block);
		var limiter = document.createElement("div");
		limiter.className = "item-limiter";
		limiter = block.appendChild(limiter);
		var wrapper = document.createElement("div");
		wrapper.className = "item-wrapper";
		wrapper = limiter.appendChild(wrapper);
		
		var image = document.createElement("img");
		image.className = "item-image-big";
		image.src = item.image_url;
		wrapper.appendChild(image);
		
		var title = document.createElement("h2");
		title.className = "item-title";
		title.innerHTML = item.title;
		wrapper.appendChild(title);
		
		if(item.title_original)
		{
			var titleOrig = document.createElement("div");
			titleOrig.className = "item-title-original";
			titleOrig.innerHTML = item.title_original;
			wrapper.appendChild(titleOrig);
		}
		
		var lineBlock;
		var bTitle;
		var bContent;
		
		if(item.rating_kinopoisk !== undefined || item.rating_imdb !== undefined)
		{
			lineBlock = document.createElement("div");
			lineBlock.className = "line-block";
			lineBlock = wrapper.appendChild(lineBlock);
			bTitle = document.createElement("div");
			bTitle.className = "line-block-title";
			bTitle.innerHTML = "Рейтинг";
			lineBlock.appendChild(bTitle);
			bContent = document.createElement("div");
			bContent.className = "line-block-content";
			bContent = lineBlock.appendChild(bContent);
			if(item.rating_kinopoisk !== undefined)
			{
				var ratingKp = document.createElement("span");
				ratingKp.className = "rating-kinopoisk";
				ratingKp.innerHTML = "" + (Math.round(item.rating_kinopoisk * 10) / 10);
				bContent.appendChild(ratingKp);
			}
			if(item.rating_imdb !== undefined)
			{
				var ratingImdb = document.createElement("span");
				ratingImdb.className = "rating-imdb";
				ratingImdb.innerHTML = "" + (Math.round(item.rating_imdb * 10) / 10);
				bContent.appendChild(ratingImdb);
			}
		}
		
		lineBlock = document.createElement("div");
		lineBlock.className = "line-block";
		lineBlock = wrapper.appendChild(lineBlock);
		bTitle = document.createElement("div");
		bTitle.className = "line-block-title";
		bTitle.innerHTML = "Жанры";
		lineBlock.appendChild(bTitle);
		bContent = document.createElement("div");
		bContent.className = "line-block-content";
		bContent.innerHTML = item.genre;
		lineBlock.appendChild(bContent);
		
		lineBlock = document.createElement("div");
		lineBlock.className = "line-block";
		lineBlock = wrapper.appendChild(lineBlock);
		bTitle = document.createElement("div");
		bTitle.className = "line-block-title";
		bTitle.innerHTML = "Год";
		lineBlock.appendChild(bTitle);
		bContent = document.createElement("div");
		bContent.className = "line-block-content";
		bContent.innerHTML = item.year;
		lineBlock.appendChild(bContent);
		
		lineBlock = document.createElement("div");
		lineBlock.className = "line-block";
		lineBlock = wrapper.appendChild(lineBlock);
		bTitle = document.createElement("div");
		bTitle.className = "line-block-title";
		bTitle.innerHTML = "Страна";
		lineBlock.appendChild(bTitle);
		bContent = document.createElement("div");
		bContent.className = "line-block-content";
		bContent.innerHTML = item.country;
		lineBlock.appendChild(bContent);
		
		if(item.age !== undefined)
		{
			lineBlock = document.createElement("div");
			lineBlock.className = "line-block";
			lineBlock = wrapper.appendChild(lineBlock);
			bTitle = document.createElement("div");
			bTitle.className = "line-block-title";
			bTitle.innerHTML = "Возраст";
			lineBlock.appendChild(bTitle);
			bContent = document.createElement("div");
			bContent.className = "line-block-content";
			bContent.innerHTML = item.age + "+";
			lineBlock.appendChild(bContent);
		}
		
		if(item.director)
		{
			lineBlock = document.createElement("div");
			lineBlock.className = "line-block";
			lineBlock = wrapper.appendChild(lineBlock);
			bTitle = document.createElement("div");
			bTitle.className = "line-block-title";
			bTitle.innerHTML = "Режиссёр";
			lineBlock.appendChild(bTitle);
			bContent = document.createElement("div");
			bContent.className = "line-block-content";
			bContent.innerHTML = item.director;
			lineBlock.appendChild(bContent);
		}
		
		if(item.motto)
		{
			lineBlock = document.createElement("div");
			lineBlock.className = "line-block";
			lineBlock = wrapper.appendChild(lineBlock);
			bTitle = document.createElement("div");
			bTitle.className = "line-block-title";
			bTitle.innerHTML = "Девиз";
			lineBlock.appendChild(bTitle);
			bContent = document.createElement("div");
			bContent.className = "line-block-content";
			bContent.innerHTML = "«" + item.motto + "»";
			lineBlock.appendChild(bContent);
		}
		
		if(item.producer)
		{
			lineBlock = document.createElement("div");
			lineBlock.className = "line-block";
			lineBlock = wrapper.appendChild(lineBlock);
			bTitle = document.createElement("div");
			bTitle.className = "line-block-title";
			bTitle.innerHTML = "Продюсер";
			lineBlock.appendChild(bTitle);
			bContent = document.createElement("div");
			bContent.className = "line-block-content";
			bContent.innerHTML = item.producer;
			lineBlock.appendChild(bContent);
		}
		
		if(item.writer)
		{
			lineBlock = document.createElement("div");
			lineBlock.className = "line-block";
			lineBlock = wrapper.appendChild(lineBlock);
			bTitle = document.createElement("div");
			bTitle.className = "line-block-title";
			bTitle.innerHTML = "Сценарист";
			lineBlock.appendChild(bTitle);
			bContent = document.createElement("div");
			bContent.className = "line-block-content";
			bContent.innerHTML = item.writer;
			lineBlock.appendChild(bContent);
		}
		
		if(item.cast)
		{
			lineBlock = document.createElement("div");
			lineBlock.className = "line-block";
			lineBlock = wrapper.appendChild(lineBlock);
			bTitle = document.createElement("div");
			bTitle.className = "line-block-title";
			bTitle.innerHTML = "В ролях";
			lineBlock.appendChild(bTitle);
			bContent = document.createElement("div");
			bContent.className = "line-block-content";
			bContent.innerHTML = item.cast;
			lineBlock.appendChild(bContent);
		}
		
		if(item.budget)
		{
			lineBlock = document.createElement("div");
			lineBlock.className = "line-block";
			lineBlock = wrapper.appendChild(lineBlock);
			bTitle = document.createElement("div");
			bTitle.className = "line-block-title";
			bTitle.innerHTML = "Бюджет";
			lineBlock.appendChild(bTitle);
			bContent = document.createElement("div");
			bContent.className = "line-block-content";
			bContent.innerHTML = item.budget;
			lineBlock.appendChild(bContent);
		}
		
		if(item.runtime)
		{
			var length = "";
			if(item.runtime.hours)
			{
				var v = item.runtime.hours;
				length += v + " ";
				v %= 100;
				if(v >= 11 && v < 20)
					v = 0;
				v %= 10;
				if(v == 0 || v >= 5)
					length += "часов";
				else if(v == 1)
					length += "час";
				else
					length += "часа";
			}
			if(item.runtime.minutes)
			{
				var v = item.runtime.minutes;
				if(length)
					length += ", ";
				length += v + " ";
				v %= 100;
				if(v >= 11 && v < 20)
					v = 0;
				v %= 10;
				if(v == 0 || v >= 5)
					length += "минут";
				else if(v == 1)
					length += "минута";
				else
					length += "минуты";
			}
			lineBlock = document.createElement("div");
			lineBlock.className = "line-block";
			lineBlock = wrapper.appendChild(lineBlock);
			bTitle = document.createElement("div");
			bTitle.className = "line-block-title";
			bTitle.innerHTML = "Длительность";
			lineBlock.appendChild(bTitle);
			bContent = document.createElement("div");
			bContent.className = "line-block-content";
			bContent.innerHTML = length;
			lineBlock.appendChild(bContent);
		}
		
		var descriptionBlock = document.createElement("div");
		descriptionBlock.className = "item-description";
		descriptionBlock.innerHTML = item.storyline;
		wrapper.appendChild(descriptionBlock);
		
		var backButton = document.createElement("div");
		backButton.id = "back_button";
		backButton.className = "back-button nav-item";
		backButton.innerHTML = "Назад";
		backButton = block.appendChild(backButton);
		(function() {
			var filmId = item.internalId;
			$(backButton).on("click", function () {
				o.$connector.Return();
			});
		})();
		
		var playButton = document.createElement("div");
		playButton.className = "play-button nav-item";
		playButton.innerHTML = "Посмотреть";
		playButton = block.appendChild(playButton);
		(function() {
			var filmId = item.internalId;
			$(playButton).on("click", function () {
				o.$connector.Play(filmId);
			});
		})();
		return playButton;
	},
	
	renderNotFound: function (block) {
		var message = document.createElement("h2");
		message.className = "item-not-found";
		message.innerHTML = "Объект не найден";
		block.appendChild(message);
		return $("#back_button")[0];
	},
	
	renderPage: function (items, pageNum, pageCount) {
		var i;
		var blocks = $(".navigation-items .navigation-item");
		for(i = 0; i < items.length && i < blocks.length; i++)
		{
			this.renderFilm(items[i], blocks[i], i);
			$(blocks[i]).show();
		}
		for(;i < blocks.length;i++)
			$(blocks[i]).hide();
		$(".navigation-info")[0].innerHTML = "Страница " + pageNum + " из " + pageCount;
		return blocks;
	},

	renderFilm: function (item, block, num) {
		while(block.childNodes.length > 0)
			block.removeChild(block.childNodes[0]);
		//block clear...
		block.setAttribute("internal_id", item.internalId);
		block.setAttribute("nav_num", num);
		
		var imgBlock = document.createElement("img");
		imgBlock.className = "film_nav_img";
		imgBlock.src = item.image_url;
		block.appendChild(imgBlock);
		
		var numBlock = document.createElement("div");
		numBlock.className = "film_nav_num";
		numBlock.innerHTML = "" + ((num + 1) % 10);
		block.appendChild(numBlock);
		
		var dataBlock = document.createElement("div");
		dataBlock.className = "film_nav_data";
		dataBlock = block.appendChild(dataBlock);
		
		var nameBlock = document.createElement("div");
		nameBlock.className = "film_nav_name";
		nameBlock.innerHTML = item.title;
		dataBlock.appendChild(nameBlock);
		
		dataBlock.appendChild(document.createElement("br"));
		
		var genreBlock = document.createElement("div");
		genreBlock.className = "film_nav_genre";
		genreBlock.innerHTML = item.genre;
		dataBlock.appendChild(genreBlock);
		
		var yearBlock = document.createElement("div");
		yearBlock.className = "film_nav_year";
		yearBlock.innerHTML = "" + item.year;
		block.appendChild(yearBlock);
		
		var yearBlock = document.createElement("div");
		yearBlock.className = "film_nav_quality";
		yearBlock.innerHTML = "" + item.quality + "p";
		block.appendChild(yearBlock);
		
		var rateBlock = document.createElement("div");
		rateBlock.className = "film_nav_rate";
		rateBlock.innerHTML = "" + (Math.round(item.rating * 10) / 10);
		block.appendChild(rateBlock);
	},
  };

  // main app initialize when smartbox ready
  SB(_.bind(App.initialize, App));
})();