function PlayerBanner()
{
	var o = this;
	var b = $("body")[0];
	
	this.enabled = false;
	this.visible = false;
	this.timer = null;
	this.animator = null;
	this.animationFrame = 0;
	this.animationFrameWidth = 0;
	this.animationFramesCount = 0;
	
	this.permanentBanner = null;
	this.isCurrentPermanent = false;
	
	this.permanentKey = 0;
	
	(function(){
		o.container = document.createElement("div");
		o.container.className = "player-banner";
		o.container = b.appendChild(o.container);
		o.icon = document.createElement("div");
		o.icon.className = "player-banner-icon";
		o.icon = o.container.appendChild(o.icon);
		o.label = document.createElement("div");
		o.label.className = "player-banner-label";
		o.label = o.container.appendChild(o.label);
		$(o.container).hide();
	})();
	
	this.ShowInternal = function(timer) {
		if(this.visible)
		{
			if(this.timer != null)
			{
				clearTimeout(this.timer);
				this.timer = null;
			}
		}
		else
		{
			$(this.container).stop(true, false).animate({opacity: 1}, 200);
			this.visible = true;
		}
		var o = this;
		if(timer !== undefined && timer)
		{
			this.timer = setTimeout(function(){
				o.timer = null;
				if(o.permanentBanner != null)
					o.RestorePermanent();
				else
				{
					$(o.container).stop(true, false).animate({opacity: 0}, {duration: 200, complete: function(){o.StopAnimations();}});
					o.visible = false;
				}
			}, timer);
			this.isCurrentPermanent = false;
		}
		else
			this.isCurrentPermanent = true;
	};
	
	this.RestorePermanent = function() {
		if(this.permanentBanner == null)
			return;
		var p = this.permanentBanner;
		if(this.permanentBanner.animated)
			this.showAnimated(p.icon, p.iw, p.ih, p.text, p.framesCount, p.duration);
		else
			this.showStatic(p.icon, p.iw, p.ih, p.text);
	};
	
	this.HidePermanent = function() {
		if(!this.visible || this.permanentBanner == null)
			return;
		this.permanentBanner = null;
		if(!this.isCurrentPermanent)
			return;
		var o = this;
		$(this.container).stop(true, false).animate({opacity: 0}, {duration: 200, complete: function(){o.StopAnimations();}});
		this.visible = false;
	}

	this.StopAnimations = function() {
		if(this.animator == null)
			return;
		clearInterval(this.animator);
		this.animator = null;
		$(this.icon).css("background-position-x", "");
	};
	
	this.BeginAnimation = function(frameWidth, framesCount, duration) {
		this.StopAnimations();
		this.animationFrame = 0;
		this.animationFrameWidth = frameWidth;
		this.animationFramesCount = framesCount;
		this.animator = setInterval(function(){o.AnimateNext()}, Math.round(duration / framesCount));
	}

	this.AnimateNext = function(){
		this.animationFrame++;
		if(this.animationFrame >= this.animationFramesCount)
			this.animationFrame = 0;
		$(this.icon).css("background-position-x", "-" + (this.animationFrame * this.animationFrameWidth) + "px");
	};
	
	this.ShowStatic = function(icon, iw, ih, text, timer){
		this.StopAnimations();
		$(this.icon).css("width", iw + "px").css("height", ih + "px").css("background-image", "url(" + icon + ")");
		this.label.innerHTML = text;
		if(!text.length)
			$(this.label).hide();
		else
			$(this.label).show();
		if(timer == undefined || !timer)
			this.permanentBanner = {
				animated: false,
				icon: icon,
				iw: iw,
				ih: ih,
				text: text
			};
		this.ShowInternal(timer);
	};
	
	this.ShowAnimated = function(icon, iw, ih, text, framesCount, duration, timer){
		this.StopAnimations();
		$(this.icon).css("width", iw + "px").css("height", ih + "px").css("background-image", "url(" + icon + ")");
		this.label.innerHTML = text;
		if(!text.length)
			$(this.label).hide();
		else
			$(this.label).show();
		this.BeginAnimation(iw, framesCount, duration);
		if(timer == undefined || !timer)
			this.permanentBanner = {
				animated: true,
				icon: icon,
				iw: iw,
				ih: ih,
				text: text,
				framesCount: framesCount,
				duration: duration
			};
		this.ShowInternal(timer);
	};
}

PlayerBanner.prototype.Enable = function()
{
	if(this.enabled)
		return;
	this.enabled = true;
	$(this.container).css("opacity", 0).show();
}

PlayerBanner.prototype.Disable = function()
{
	if(!this.enabled)
		return;
	this.StopAnimations();
	this.enabled = false;
	$(this.container).stop(true, false).hide().css("opacity", "");
}

PlayerBanner.prototype.ModeFull = function()
{
	if(!this.enabled)
		return;
	this.ShowStatic("img/mode-full.png", 32, 18, "Растянуть", 5000);
}

PlayerBanner.prototype.ModeLetter = function()
{
	if(!this.enabled)
		return;
	this.ShowStatic("img/mode-letter.png", 31, 18, "Вписать", 5000);
}

PlayerBanner.prototype.ModePanandscan = function()
{
	if(!this.enabled)
		return;
	this.ShowStatic("img/mode-panandscan.png", 21, 18, "Оптимально", 5000);
}

PlayerBanner.prototype.ModeZoom = function()
{
	if(!this.enabled)
		return;
	this.ShowStatic("img/mode-zoom.png", 17, 18, "Увеличить", 5000);
}

PlayerBanner.prototype.Play = function(shortTimer)
{
	if(!this.enabled)
		return;
	this.ShowStatic("img/play-icon.png", 25, 25, "", shortTimer ? 700 :2000);
}

PlayerBanner.prototype.Pause = function(shortTimer)
{
	if(!this.enabled)
		return;
	this.ShowStatic("img/pause-icon.png", 25, 25, "", shortTimer ? 700 : 15000);
}

PlayerBanner.prototype.BeginBuffering = function()
{
	if(!this.enabled)
		return;
	this.ShowAnimated("img/wait.png", 23, 25, "Буферизация", 29, 900);
	this.permanentKey = 1;
}

PlayerBanner.prototype.StopBuffering = function()
{
	if(!this.enabled || this.permanentKey != 1)
		return;
	this.HidePermanent();
}

PlayerBanner.prototype.BeginLoading = function()
{
	if(!this.enabled)
		return;
	this.ShowAnimated("img/wait.png", 23, 25, "Соединение", 29, 900);
	this.permanentKey = 2;
}

PlayerBanner.prototype.StopLoading = function()
{
	if(!this.enabled || this.permanentKey != 2)
		return;
	this.HidePermanent();
}




